summaryrefslogtreecommitdiffstats
path: root/development/cargo/cargo.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to '')
-rw-r--r--development/cargo/cargo.SlackBuild234
1 files changed, 234 insertions, 0 deletions
diff --git a/development/cargo/cargo.SlackBuild b/development/cargo/cargo.SlackBuild
new file mode 100644
index 0000000000..7fbf7dcd26
--- /dev/null
+++ b/development/cargo/cargo.SlackBuild
@@ -0,0 +1,234 @@
+#!/bin/sh
+
+# Slackware build script for cargo
+
+# Copyright 2017 Andrew Clemons, Wellington New Zealand
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=cargo
+VERSION=${VERSION:-0.17.0}
+VERSION_BOOTSTRAP=${VERSION_BOOTSTRAP:-0.16.0}
+VERSION_RUST_INSTALLER=${VERSION_RUST_INSTALLER:-4f994850808a572e2cc8d43f968893c8e942e9bf}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+
+(
+ # versioned git submodule from cargo tag
+ cd src
+ rm -rf rust-installer
+ tar xvf $CWD/rust-installer-$VERSION_RUST_INSTALLER.tar.gz
+ mv rust-installer-$VERSION_RUST_INSTALLER rust-installer
+)
+
+# if you already have rust and cargo installed, you can bootstrap from the
+# previous version.
+if [ "$LOCAL_BOOTSTRAP" = "" ] && [ -x /usr/bin/cargo ] && [ -x /usr/bin/rustc ] ; then
+ LOCAL_BOOTSTRAP=yes
+fi
+
+if [ "$LOCAL_BOOTSTRAP" = "yes" ] ; then
+ local_cargo="/usr/bin/cargo"
+else
+ tar xvf $CWD/cargo-$VERSION_BOOTSTRAP-$ARCH-unknown-linux-gnu.tar.gz
+
+ local_cargo="$(pwd)/cargo-nightly-$ARCH-unknown-linux-gnu/cargo/bin/cargo"
+fi
+
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc \
+ --localstatedir=/var \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --rustc=/usr/bin/rustc \
+ --rustdoc=/usr/bin/rustdoc \
+ --local-rust-root=/usr \
+ --cargo="$local_cargo"
+
+# build offline
+# configuration tells cargo to use the configured directory
+# for dependencies intead of downloading from crates.io.
+mkdir .cargo
+cat << EOF >> .cargo/config
+[source.crates-io]
+registry = 'https://github.com/rust-lang/crates.io-index'
+replace-with = 'vendored-sources'
+
+[source.vendored-sources]
+directory = '$(pwd)/vendor'
+EOF
+
+# deps and versions come from Cargo.lock
+# cargo vender can be used to generate the checksums
+mkdir vendor
+(
+ cd vendor
+
+ for dependency in advapi32-sys=0.2.0 \
+ aho-corasick=0.5.3 \
+ bitflags=0.7.0 \
+ bufstream=0.1.2 \
+ cfg-if=0.1.0 \
+ cmake=0.1.19 \
+ crossbeam=0.2.10 \
+ curl=0.4.1 \
+ curl-sys=0.3.6 \
+ docopt=0.6.86 \
+ env_logger=0.3.5 \
+ error-chain=0.7.2 \
+ filetime=0.1.10 \
+ flate2=0.2.14 \
+ fs2=0.3.0 \
+ gcc=0.3.39 \
+ gdi32-sys=0.2.0 \
+ git2=0.6.3 \
+ git2-curl=0.7.0 \
+ glob=0.2.11 \
+ hamcrest=0.1.1 \
+ idna=0.1.0 \
+ kernel32-sys=0.2.2 \
+ lazy_static=0.2.2 \
+ libc=0.2.18 \
+ libgit2-sys=0.6.6 \
+ libssh2-sys=0.2.5 \
+ libz-sys=1.0.13 \
+ log=0.3.6 \
+ matches=0.1.4 \
+ memchr=0.1.11 \
+ metadeps=1.1.1 \
+ miniz-sys=0.1.7 \
+ miow=0.1.3 \
+ net2=0.2.26 \
+ num=0.1.36 \
+ num-bigint=0.1.35 \
+ num-complex=0.1.35 \
+ num-integer=0.1.32 \
+ num-iter=0.1.32 \
+ num-rational=0.1.35 \
+ num-traits=0.1.36 \
+ num_cpus=1.1.0 \
+ openssl=0.9.6 \
+ openssl-probe=0.1.0 \
+ openssl-sys=0.9.6 \
+ pkg-config=0.3.8 \
+ psapi-sys=0.1.0 \
+ rand=0.3.14 \
+ regex=0.1.80 \
+ regex-syntax=0.3.9 \
+ rustc-serialize=0.3.21 \
+ semver=0.5.1 \
+ semver-parser=0.6.1 \
+ shell-escape=0.1.3 \
+ strsim=0.5.1 \
+ tar=0.4.9 \
+ tempdir=0.3.5 \
+ term=0.4.4 \
+ thread-id=2.0.0 \
+ thread_local=0.2.7 \
+ toml=0.2.1 \
+ unicode-bidi=0.2.3 \
+ unicode-normalization=0.1.2 \
+ url=1.2.3 \
+ user32-sys=0.2.0 \
+ utf8-ranges=0.1.3 \
+ winapi=0.2.8 \
+ winapi-build=0.1.1 \
+ ws2_32-sys=0.2.1 ; do
+
+ dep="$(echo "$dependency" | cut -d= -f1)"
+ ver="$(echo "$dependency" | cut -d= -f2)"
+
+ tar xvf $CWD/$dep-$ver.crate
+
+ mv $dep-$ver $dep
+
+ touch $dep/.cargo-ok
+ zcat $CWD/checksums/$dep-cargo-checksum.json.gz > $dep/.cargo-checksum.json
+ done
+)
+
+make
+make install DESTDIR=$PKG
+
+if [ "$ARCH" = "x86_64" ]; then
+ mv $PKG/usr/lib $PKG/usr/lib$LIBDIRSUFFIX
+fi
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a LICENSE-APACHE LICENSE-MIT LICENSE-THIRD-PARTY README.md $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}